import logging
from monitoring_template.settings import LoggerConfig, ServiceConfig
import logging_loki
from multiprocessing import Queue

logger = None


def get_logger():
    global logger
    if not logger:
        logger = logging.getLogger(ServiceConfig.SERVICE_NAME)
        logger.setLevel(LoggerConfig.LOG_LEVEL)
        log_format = logging.Formatter('[%(levelname)s] - %(message)s')

        loki_handler = logging_loki.LokiQueueHandler(
            Queue(-1),
            url=f"{LoggerConfig.LOG_ENDPOINT}",
            tags={
                "service": ServiceConfig.SERVICE_NAME
            },
            version="1",
        )
        loki_handler.setFormatter(log_format)

        console_handler = logging.StreamHandler()

        logger.addHandler(loki_handler)
        logger.addHandler(console_handler)

    return logger

